[CCode (cheader_filename = "libgreattao/tao.h")]
namespace Tao {

  
  [CCode (cname = "tao_set_hint")]
  public   void set_hint (void *window, string epath, char hint_type, void *data);  
  [CCode (cname = "tao_get_requested_program_version")]
  public   char *get_requested_program_version();
  [CCode (cname = "tao_initialize")]
  public   int initialize(string app_name, string help_text, int *argc, [CCode (array_length = false)] string argv[]);
  [CCode (cname = "tao_new_window")]
  public   void *new_window(char *cpath);
  //[CCode (cname = "tao_new_window_error_handling")]
  //public   void *new_window_error_handling(char *cpath, void (*on_error)(void *),  void *data);
  [CCode (cname = "tao_attach_window")]
  public   void attach_window(void *parent_, string spath, void *child_);
  [CCode (cname = "tao_deactivate_handler")]
  public   void deactivate_handler(void *object_, char *epath);
  [CCode (cname = "tao_activate_handler")]
  public   void activate_handler(void *object_, char *epath);
  [CCode (cname = "tao_delete_handlers")]
  public   void delete_handlers(void *window_, string path);
  [CCode (cname = "tao_handle_events")]
  public   void handle_events();
  [CCode (cname = "tao_run_event_iterration")]
  public   void run_event_iterration();
  [CCode (cname = "tao_set_alternative_design")]
  public   void set_alternative_design(char *path);
  [CCode (cname = "tao_close")]
  public   void close();
  [CCode (cname = "tao_release_window")]
  public   void release_window(void *window_);
  [CCode (cname = "tao_change_weight")]
  public   void change_weight(void *window_, char *epath, int new_weight);
  [CCode (cname = "tao_add_handler")]
  public   void add_handler(void *window_, string epath, void *callback, void *data);
  //[CCode (cname = "tao_add_timer")]
 // public   void *add_timer(int miliseconds, void (*callback)(void*), void *data);
  //[CCode (cname = "tao_remove_timer")]
  //public   void remove_timer(void *timer);
  [CCode (cname = "tao_set_modal")]
  public   void set_modal(void *parent_, string spath, void *child_, char type);
 // [CCode (cname = "tao_set_exit_callback")]
 // public   void set_exit_callback(int (*callback)(void*));
//  [CCode (cname = "tao_data_signed_integer")]
  //public   char data_signed_integer(struct obinded *window, char *epath, char flags, int min, int max);
  //[CCode (cname = "tao_data_unsigned_integer")]
  //public   char data_unsigned_integer(struct obinded *window, char *epath, char flags, int min, int max);
  //[CCode (cname = "tao_data_string")]
  //public   char data_string(struct obinded *window, char *epath, char flags, int max_length);
  [CCode (cname = "tao_get_integer")]
  public   int get_integer(void *window_, char *epath, int *error);
  [CCode (cname = "tao_get_string")]
  public   char *get_string(void *window_, char *epath, int *error);
  [CCode (cname = "tao_set_string")]
  public   int set_string(void *window_, char *epath, char *data);
  [CCode (cname = "tao_set_license_notice_and_text")]
  public   void set_license_notice_and_text(string notice, string text);
  [CCode (cname = "tao_open_file")]
  public   int open_file(string path, int flags, int mode);
  [CCode (cname = "tao_close_file")]
  public   void close_file(int fd);
  [CCode (cname = "tao_release_file")]
  public   void release_file(string path);
  [CCode (cname = "tao_display_windows")]
  public   void display_windows(int count, void **windows);
  //struct tao_image *tao_blit_image(struct tao_image *src, struct tao_image *dst, long long x, long long y, string *descriptions);
  /* images */
/*  
  struct canvas {
    
    void *handler;
    void *widget;
    long long width,height;
    struct canvas *next;
  };
  
  struct sprite {
    
    long long x, y;
    long long w, h;
    void *surface;
    struct sprite *next;
  };
  
  
  struct tao_image {
    struct tao_image *higher;
    struct tao_image *lower;
    void *real_image;
    void *descriptions;
  };
  
  struct tao_image *tao_load_image(string path, void (*callback)(void*, void*), void *parameter);
  struct tao_image *tao_new_image(long long x, long long y, void (*callback)(void*, void*), void *parameter);
  struct canvas *tao_get_canvas(struct obinded *window, string epath);
  void *tao_get_unlocked_image(void *locked_image);
  uint64_t tao_get_image_width(void *image);
  uint64_t tao_get_image_height(void *image);
  void tao_release_canvases(struct canvas *fcanvas);
  void tao_draw(struct canvas *canvas, struct tao_image *image, long long x, long long y, string *descriptions);
  void *tao_new_icon_set(void);
  void tao_add_image_to_icon_set(void *is, struct tao_image *im);
  void tao_put_pixel(void *image, uint64_t x, uint64_t y, char r, char g, char b, char a);
  uint32_t tao_get_pixel(void *image, uint64_t x, uint64_t y);
  
  enum hint_type { HINT_NAME, HINT_DESCRIPTION, HINT_HELP, HINT_ICON, HINT_CHARACTER };
*/  
}

[CCode (cheader_filename = "libgreattao/log.h")]
namespace TaoLog {

  [CCode (cname = "tao_log_custom")]
  void custom(string function, string module, string reason, 
                      string message,string file, int line, int flags);
}

[CCode (cheader_filename = "libgreattao/config.h", cprefix="")]
namespace TaoConfig {

  [CCode (cname = "struct tao_app_config_option")]
  struct tao_app_config_option {
    string option_name;
    string visible_name;
    string visible_description;
    uint8  type;
    uint8  short_option;
    uint8 flags;
  }
  
  [CCode (cname = "struct tao_app_config_result")]
  struct tao_app_config_result {
    [CCode (cname = "result")]
    void *result_;
    uint8    error;
    [CCode (cname = "set")]
    uint8     set_;
  }
  
  /* struct tao_app_config_option types */
  [CCode (cname = "TAO_TYPE_INT")]
  const uint8 TAO_TYPE_INT				;
  [CCode (cname = "TAO_TYPE_UINT")]
  const uint8 TAO_TYPE_UINT			        ;
  [CCode (cname = "TAO_TYPE_STRING")]
  const uint8 TAO_TYPE_STRING			;
  [CCode (cname = "TAO_TYPE_FILE_PATH")]
  const uint8 TAO_TYPE_FILE_PATH			;
  /* struct tao_app_config_option flags */
  [CCode (cname = "TAO_CONFIG_OPTION_ARG_TAO_DECORATOR")]
  const uint8 TAO_CONFIG_OPTION_ARG_TAO_DECORATOR	;
  [CCode (cname = "TAO_CONFIG_OPTION_ARG_LONG_DECORATOR")]
  const uint8 TAO_CONFIG_OPTION_ARG_LONG_DECORATOR	;
  [CCode (cname = "TAO_CONFIG_OPTION_ARG_CHARACTER_DECORATOR")]
  const uint8 TAO_CONFIG_OPTION_ARG_CHARACTER_DECORATOR;
  [CCode (cname = "TAO_CONFIG_OPTION_FROM_NETWORK")]
  const uint8 TAO_CONFIG_OPTION_FROM_NETWORK	;
  
  /* tao_get_app_configuration flags */
  [CCode (cname = "TAO_APP_CONFIG_FROM_FILE")]
  const uint8 TAO_APP_CONFIG_FROM_FILE		;
  [CCode (cname = "TAO_APP_CONFIG_FROM_LINE")]
  const uint8 TAO_APP_CONFIG_FROM_LINE		;
  [CCode (cname = "TAO_APP_CONFIG_INTERACTIVE")]
  const uint8 TAO_APP_CONFIG_INTERACTIVE	        ;
  [CCode (cname = "TAO_APP_CONFIG_INTERACTIVE_FORCE")]
  const uint8 TAO_APP_CONFIG_INTERACTIVE_FORCE	;
  [CCode (cname = "TAO_APP_CONFIG_FROM_NETWORK")]
  const uint8 TAO_APP_CONFIG_FROM_NETWORK		;

  [CCode (cname = "tao_get_app_configuration")]
  int tao_get_app_configuration(tao_app_config_option *options_array, 
                                tao_app_config_result *results, 
                                int option_array_length, 
                                int flags);
  
}
